---------------------------------------------------------------------------------------------------
-- Addon Manager
---------------------------------------------------------------------------------------------------
Global( "addon", {
	_R = {},
	--[[colors = {
		CL1 = { r = 101 / 255, g = 135 / 255, b = 145 / 255, a = 0.5 },
		CL2 = { r = 62 / 255, g = 105 / 255, b = 115 / 255, a = 0.5 }
	},--]]
	widgets = {	elems = {}, selected = {} },
	--[[ver = {
		MAJOR = 0,
		MINOR = 3
	},--]]
	isDefaultShowed = false,
	isListUpdated = true,
	isUIShowed = true,
	counter = 0,
	
	MEM_USAGE_REQUEST_DELAY = 5,
	PREFIX = "UserAddon/",
	SLASH_COMMAND = "\/am"
} )
---------------------------------------------------------------------------------------------------
addon._R[ "EVENT_UNKNOWN_SLASH_COMMAND" ] = function( event )
	if addon.SLASH_COMMAND == FrWS( event.text ) then W( "MainPanel" ):Show( not W( "MainPanel" ):IsVisible() ) end
end

addon._R[ "EVENT_SECOND_TIMER" ] = function()
	if avatar.IsExist() and W( "MainPanel" ):IsVisible() then
		addon.counter = addon.counter + 1
		if not addon.isListUpdated --[[and table.getn( addon.widgets.elems ) > 0--]] then
			for _, v in ipairs( common.GetStateManagedAddons() ) do
				W( "ButtonToggleAddonState", addon.widgets.elems[ v.name ].w ):SetVariant( v.isLoaded and 1 or 0 )
				if HasNamePrefix( v.name ) then
					W( "ButtonToggleDND", addon.widgets.elems[ v.name ].w ):Enable( v.isLoaded )
					if not v.isLoaded then W( "MemUsage", addon.widgets.elems[ v.name ].w ):ClearValues() end
				end
			end
			addon:Update()
		end
		if addon.counter == addon.MEM_USAGE_REQUEST_DELAY then userMods.SendEvent( "U_EVENT_ADDON_MEM_USAGE_REQUEST", {} ); addon.counter = 0 end		
	end
end

addon._R[ "EVENT_AVATAR_CREATED" ] = function()
	for _, v in ipairs( common.GetStateManagedAddons() ) do addon:AddItem( v ) end
	addon:Repaint()
	addon.isListUpdated = false
end

addon._R[ "U_EVENT_ADDON_MEM_USAGE_REQUEST" ] = function( event )
	userMods.SendEvent( "U_EVENT_ADDON_MEM_USAGE_RESPONSE", { sender = common.GetAddonName(), memUsage = gcinfo() } )
end

addon._R[ "U_EVENT_ADDON_MEM_USAGE_RESPONSE" ] = function( event )
	if addon.widgets.elems[ addon.PREFIX .. event.sender ] then
		W( "MemUsage", addon.widgets.elems[ addon.PREFIX .. event.sender ].w ):SetVal( "value", ToWS( string.format( "%dKiB", event.memUsage ) ) )
	end
end

addon._R[ "mouse_left_click" ] = function( reaction )
	local parent = reaction.widget:GetParent()
	local b = reaction.widget:GetVariant() == 1
	local isSelected = table.getn( addon.widgets.selected ) > 0
	if reaction.sender == "ButtonItem" then
		local t, n = addon.widgets.selected, parent:GetName()
		if n == addon.PREFIX .. common.GetAddonName() then return end
		if not b then table.insert( t, n ) else for i, v in ipairs( t ) do if v == n then table.remove( t, i ) end end end
		reaction.widget:SetVariant( b and 0 or 1 )
		isSelected = table.getn( addon.widgets.selected ) > 0
		W( "ButtonLoadSelected" ):Enable( isSelected );	W( "ButtonUnLoadSelected" ):Enable( isSelected )
		return
	elseif reaction.sender == "TabUser" then
		W( "TabDefault" ):SetVariant( 0 )
		addon.isDefaultShowed = false
		addon:Repaint()
	elseif reaction.sender == "TabDefault" then
		W( "TabUser" ):SetVariant( 0 )
		addon.isDefaultShowed = true
		addon:Repaint()
	elseif reaction.sender == "ButtonLoadAll" then
		for k in pairs( addon.widgets.elems ) do if HasNamePrefix( k ) then common.StateLoadManagedAddon( k ) end end
	elseif reaction.sender == "ButtonUnLoadAll" then
		for k in pairs( addon.widgets.elems ) do
			if HasNamePrefix( k ) and k ~= addon.PREFIX .. common.GetAddonName() then common.StateUnloadManagedAddon( k ) end
		end
	--[[elseif reaction.sender == "ButtonShowDefault" then
		addon.isDefaultShowed = not b
		addon:Repaint()--]]
	elseif reaction.sender == "ButtonToggleDND" then
		userMods.SendEvent( "U_EVENT_TOGGLE_DND", { target = GetName( parent:GetName() ), state = not b } )
		addon.widgets.elems[ parent:GetName() ].bDNDState = not b
		reaction.widget:SetVariant( b and 0 or 1 )		
		return
	elseif reaction.sender == "ButtonToggleUI" then
		addon.isUIShowed = not addon.isUIShowed
		reaction.widget:SetVal( "button_label", ToWS( addon.isUIShowed and L[ "Hide All" ] or L[ "Show All" ] ) )
		userMods.SendEvent( "SCRIPT_TOGGLE_UI", { visible = addon.isUIShowed } )
		--common.LogInfo( "common", tostring( addon.isUIShowed ) )
		return
	elseif reaction.sender == "ButtonCornerCross" then
		W( "MainPanel" ):Show( false ); return 0
	elseif reaction.sender == "ButtonSave" then
		addon:SaveConfig()	
	elseif reaction.sender == "ButtonReset" then
		--addon:Reset()
		--addon._R[ "EVENT_AVATAR_CREATED" ]()
	elseif reaction.sender == "ButtonToggleAddonState" then
		if b then common.StateUnloadManagedAddon( parent:GetName() ) else common.StateLoadManagedAddon( parent:GetName() ) end
	end
	if isSelected then
		if reaction.sender == "ButtonLoadSelected" then
			for _, v in ipairs( addon.widgets.selected ) do common.StateLoadManagedAddon( v )  end
		elseif reaction.sender == "ButtonUnLoadSelected" then
			for _, v in ipairs( addon.widgets.selected ) do common.StateUnloadManagedAddon( v ) end
		end
	end
	if reaction.widget:GetVariantCount() > 1 then reaction.widget:SetVariant( b and 0 or 1 ) end
	addon:Update( true )
end

addon._R[ "mouse_right_click" ] = function( reaction )
	--LogInfo( reaction.sender )
end
---------------------------------------------------------------------------------------------------
addon.AddItem = function( self, v )
	mainForm:CreateWidgetByDesc( self.widgets.elemDesc ):SetName( v.name )
	local t = {
		w = W( v.name ),
		comment = self.config[ v.name ] and self.config[ v.name ].comment or "-"
	}
	if self.config[ v.name ] and not self.config[ v.name ].state then common.StateUnloadManagedAddon( v.name ) end
	W( "ButtonToggleAddonState", t.w ):SetVariant( v.isLoaded and 1 or 0 )
	if HasNamePrefix( v.name ) then
		W( "ButtonToggleDND", t.w ):SetVariant( --[[self.config[ v.name ] and self.config[ v.name ].bDNDState and 1 or 0--]] 1 )
		W( "ButtonToggleDND", t.w ):Show( true ); W( "MemUsage", t.w ):Show( true )
	end
	if v.name == self.PREFIX .. common.GetAddonName() then
		W( "ButtonToggleAddonState", t.w ):Enable( false ); W( "ButtonToggleDND", t.w ):Show( false )
	end
	--[[if self.config[ v.name ] and self.config[ v.name ].bDNDState then
		userMods.SendEvent( "U_EVENT_TOGGLE_DND", { target = GetName( v.name ), state = true } )
	end--]]
	W( "Name", t.w ):SetVal( "value", ToWS( GetName( v.name ) ) )
	W( "Comment", t.w ):SetVal( "value", ToWS( t.comment ) )
	self.widgets.elems[ v.name ] = t
end

addon.Init = function( self )
	if not ( userMods and userMods.FromWString ) then return end
	self.config = userMods.GetGlobalConfigSection( common.GetAddonName() ) or {}
	self.widgets.elemDesc = W( "Item" ):GetWidgetDesc()
	W( "Item" ):DestroyWidget()	
	--
	--W( "ButtonShowDefault" ):SetVariant( self.isDefaultShowed and 1 or 0 )
	W( "Header" ):SetVal( "value", ToWS( --[[string.format( "%s v%d\.%d",--]] L[ "Addon Manager" ]--[[, addon.ver.MAJOR, addon.ver.MINOR )--]] ) )
	W( "TabUser" ):SetVal( "button_label", ToWS( L[ "User" ] ) )
	W( "TabUser" ):SetVariant( self.isDefaultShowed and 0 or 1 )
	W( "TabDefault" ):SetVal( "button_label", ToWS( L[ "Default" ] ) )
	W( "TabDefault" ):SetVariant( self.isDefaultShowed and 1 or 0 )
	W( "ButtonToggleUI" ):SetVal( "button_label", ToWS( addon.isUIShowed and L[ "Hide All" ] or L[ "Show All" ] ) )
	W( "ButtonLoadSelected" ):SetVal( "button_label", ToWS( L[ "Load Selected" ] ) )
	W( "ButtonUnLoadSelected" ):SetVal( "button_label", ToWS( L[ "Unload Selected" ] ) )
	W( "ButtonLoadAll" ):SetVal( "button_label", ToWS( L[ "Load All" ] ) )
	W( "ButtonUnLoadAll" ):SetVal( "button_label", ToWS( L[ "Unload All" ] ) )
	W( "ButtonSave" ):SetVal( "button_label", ToWS( L[ "Save" ] ) )
	W( "ButtonReset" ):SetVal( "button_label", ToWS( L[ "Reset" ] ) )
	--W( "Label", W( "ShowDefault" ) ):SetVal( "value", ToWS( L[ "Show Default" ] ) )
	W( "ColumnDNDState" ):SetVal( "value", ToWS( L[ "Lock" ] ) )
	W( "ColumnState" ):SetVal( "value", ToWS( L[ "Status" ] ) )	
	W( "ColumnName" ):SetVal( "value", ToWS(  L[ "Name" ] ) )
	W( "ColumnComment" ):SetVal( "value", ToWS(  L[ "Comment" ] ) )
	W( "ColumnMemUsage" ):SetVal( "value", ToWS(  L[ "Memory Usage" ] ) )
	--
	self:Reg()
end

addon.Reg = function( self )
	for k, v in pairs( self._R ) do if string.find( k, "[A-Z]+_" ) then common.RegisterEventHandler( v, k ) else common.RegisterReactionHandler( v, k ) end end
end

addon.Repaint = function( self )
	local t = {}
	for k in pairs( self.widgets.elems ) do
		if self.isDefaultShowed then if not HasNamePrefix( k ) then table.insert( t, k ) end
		else if HasNamePrefix( k ) then table.insert( t, k ) end end
	end
	table.sort( t )
	W( "Container" ):RemoveItems()
	for i = 1, table.getn( t ) do
		W( "Container" ):PushBack( self.widgets.elems[ t [ i ] ].w )
		self.widgets.elems[ t [ i ] ].w:Show( true )
		--if math.mod( i, 2 ) == 0 then LogInfo( self.widgets.elems[ t [ i ] ].w:GetBackgroundColor() ) end
	end
end

addon.SaveConfig = function( self )
	for _, v in ipairs( common.GetStateManagedAddons() ) do
		self.config[ v.name ] = { state = v.isLoaded }
		local s = self.widgets.elems[ v.name ].comment
		if string.len( s ) > 0 and s ~= "-" then self.config[ v.name ].comment = s end
	end
	userMods.SetGlobalConfigSection( common.GetAddonName(), self.config )
end

addon.Update = function( self, b )
	local b = not b
	self.isListUpdated = b
	mainForm:SetFade( b and 1 or 0.90 )
	mainForm:Enable( b )
end
---------------------------------------------------------------------------------------------------
function W( s, wt ) return wt and wt:GetChildChecked( s, true ) or mainForm:GetChildChecked( s, true ) end
function ToWS( s ) return userMods.ToWString( s ) end
function FrWS( ws ) return userMods.FromWString( ws ) end

function HasNamePrefix( name ) return string.sub( name, 1, string.len( addon.PREFIX ) ) == addon.PREFIX end
function GetName( name ) return HasNamePrefix( name, addon.PREFIX ) and string.sub( name, string.len( addon.PREFIX ) + 1 ) or name end
---------------------------------------------------------------------------------------------------
addon:Init()
---------------------------------------------------------------------------------------------------